<?php
declare(strict_types=1);

namespace Catequil\User\Service;

use Catequil\User\Model\UserInterface;
use Doctrine\ORM\EntityManagerInterface;

/**
 * Class UserService
 *
 * @package Catequil\User\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-user
 */
class UserService implements UserServiceInterface
{
    private EntityManagerInterface $em;

    /**
     * @param EntityManagerInterface $em
     */
    public function __construct(EntityManagerInterface $em)
    {
        $this->em = $em;
    }

    /**
     * @param string $emailAddress
     * @return UserInterface|null
     */
    public function findUserByEmailAddress(string $emailAddress): ?UserInterface
    {
        $repo = $this->em->getRepository(UserInterface::class);
        return $repo->findOneBy(['email' => $emailAddress]);
    }
}